/***************************************************************************
 *                                                                         *
 *                         Powersave Daemon                                *
 *                                                                         *
 *          Copyright (C) 2004,2005 SUSE Linux Products GmbH               *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify it *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2 of the License, or (at you   *
 * option) any later version.                                              *
 *                                                                         *
 * This program is distributed in the hope that it will be useful, but     *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA                  *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include <string.h>
#include "powersave_dbus.h"

using namespace std;

int main(int *argc, char *argv[])
{
	char *args[3];
	// check whether there is a cmdline argument
	if (argv[2] == NULL && argv[1] != NULL) {
		char *s = strtok(argv[1], "|");
		int i = 0;
		while (s != NULL) {
			args[i++] = s;
			if (i > 1)
				break;
			s = strtok(NULL, "|");
		}
		if (i != 2) {
			cerr << "wrong return string\n";
			return 1;
		}
		s = strtok(NULL, "\0");
		args[i] = s;
	} else {
		if (argv[1] == NULL || argv[2] == NULL || argv[3] == NULL) {
			cerr << "Too less arguments given to send to the daemon\n";
			return 1;
		}
		for (int i = 0; i < 3; i++)
			args[i] = argv[i + 1];
	}

	// the event id
	int event_id = strtol(args[0], NULL, 10);

	// the request (successfull, failed, notifz, progress)
	int request = strtol(args[1], NULL, 10);

	// the message
	char *message = args[2];

	int ret = dbusSendMessage(MANAGER_MESSAGE,
				  "EventReturn",
				  DBUS_TYPE_INT32,
				  &event_id,
				  DBUS_TYPE_INT32,
				  &request,
				  DBUS_TYPE_STRING,
				  &message,
				  DBUS_TYPE_INVALID);

	if (ret != REPLY_SUCCESS)
		return 1;

	return 0;
}
